From d3797b9ed912d71158ebfa682233af91d1bf4bdb Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Thu, 28 Jul 2022 01:12:09 +0100
Subject: [PATCH 18/21] Remove pyspotify: set user/pass source properties using
 on_source_setup

---
 mopidy_spotify/backend.py | 18 ++++++++----------
 tests/test_playback.py    | 24 ++++++++++++++++++++----
 2 files changed, 28 insertions(+), 14 deletions(-)

diff --git a/mopidy_spotify/backend.py b/mopidy_spotify/backend.py
index 6ba6aa97..98869839 100644
--- a/mopidy_spotify/backend.py
+++ b/mopidy_spotify/backend.py
@@ -1,12 +1,8 @@
-import logging
-
 import pykka
 from mopidy import backend
 
 from mopidy_spotify import Extension, library, playlists, web
 
-logger = logging.getLogger(__name__)
-
 
 class SpotifyBackend(pykka.ThreadingActor, backend.Backend):
     def __init__(self, config, audio):
@@ -43,9 +39,11 @@ def on_start(self):
 class SpotifyPlaybackProvider(backend.PlaybackProvider):
     def __init__(self, *args, **kwargs):
         super().__init__(*args, **kwargs)
-        username = self.backend._config["spotify"]["username"]
-        password = self.backend._config["spotify"]["password"]
-        self._auth_string = f"username={username}&password={password}"
-
-    def translate_uri(self, uri):
-        return f"{uri}?{self._auth_string}"
+        self._cache_location = Extension().get_cache_dir(self.backend._config)
+
+    def on_source_setup(self, source):
+        config = self.backend._config["spotify"]
+        for prop in ["username", "password"]:
+            source.set_property(prop, config[prop])
+        if config["allow_cache"]:
+            source.set_property("cache-credentials", self._cache_location)
diff --git a/tests/test_playback.py b/tests/test_playback.py
index 35692e24..50a10f33 100644
--- a/tests/test_playback.py
+++ b/tests/test_playback.py
@@ -31,7 +31,23 @@ def test_is_a_playback_provider(provider):
     assert isinstance(provider, backend_api.PlaybackProvider)
 
 
-def test_translate_uri_sets_credentials(config, provider):
-    assert (
-        provider.translate_uri("baz") == "baz?username=alice&password=password"
-    )
+def test_on_source_setup_sets_properties(config, provider):
+    mock_source = mock.MagicMock()
+    provider.on_source_setup(mock_source)
+
+    assert mock_source.set_property.mock_calls == [
+        mock.call("username", "alice"),
+        mock.call("password", "password"),
+        mock.call("cache-credentials", mock.ANY),
+    ]
+
+
+def test_on_source_setup_without_caching(config, provider):
+    config["spotify"]["allow_cache"] = False
+    mock_source = mock.MagicMock()
+    provider.on_source_setup(mock_source)
+
+    assert mock_source.set_property.mock_calls == [
+        mock.call("username", "alice"),
+        mock.call("password", "password"),
+    ]

